package com.its.api.its.service.vms;

import com.its.api.its.model.dto.vms.TbVmsSymbLibDto;
import com.its.api.its.model.entity.vms.TbVmsSymbLib;
import com.its.api.its.repository.vms.TbVmsFormObjectRepository;
import com.its.api.its.repository.vms.TbVmsSymbLibRepository;
import com.its.api.utils.ItsUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
//@RequiredArgsConstructor
//@Service
public class TbVmsSymbLibService {

    private final String VMP_TYPE_CD;
    private final TbVmsSymbLibRepository repo;
    private final TbVmsFormObjectRepository formObjectRepository;

    public TbVmsSymbLibService(String vmp_type_cd, TbVmsSymbLibRepository repo, TbVmsFormObjectRepository formObjectRepository) {
        this.VMP_TYPE_CD = vmp_type_cd;
        this.repo = repo;
        this.formObjectRepository = formObjectRepository;
    }

    // 데이터 1건 조회, 없으면 exception
    public TbVmsSymbLib requireOne(Integer id) {
        return repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    /**
     * 심볼유형에 따른 이미지 심볼 데이터 조회
     * @return
     */
    public List<TbVmsSymbLibDto> findAllSymbolImage() {

        String saveDir = ItsUtils.createUserDir("/image/vms/");
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        List<TbVmsSymbLib> data = this.repo.findAllSymbolImage(this.VMP_TYPE_CD);
        if (data != null) {
            data.forEach(obj -> {
                result.add(obj.toDto());
                //ItsUtils.saveByteArrayToFile(saveDir + obj.getSymbLibNmbr() + ".bmp", obj.getImagData());
            });
        }
        return result;
    }

    // 전체 데이터 조회
    public List<TbVmsSymbLibDto> findAll() {
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        List<TbVmsSymbLib> data = this.repo.findAll();
        for (TbVmsSymbLib entity : data) {
            if (entity.getVmsTypeCd() != null && this.VMP_TYPE_CD.equals(entity.getVmsTypeCd())) {
                result.add(entity.toDto());
            }
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    public TbVmsSymbLibDto findById(Integer id) {
        TbVmsSymbLib entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    public TbVmsSymbLibDto updateById(Integer id, TbVmsSymbLibDto.TbVmsSymbLibUpdReq req) {
        TbVmsSymbLib entity = requireOne(id);
        req.setVmsTypeCd(this.VMP_TYPE_CD);
        req.setRgstDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    public List<TbVmsSymbLibDto> mergeInfoList(List<TbVmsSymbLibDto.TbVmsSymbLibUpdReq> reqList) {
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        for (TbVmsSymbLibDto.TbVmsSymbLibUpdReq req : reqList) {
            req.setVmsTypeCd(this.VMP_TYPE_CD);
            req.setRgstDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
            TbVmsSymbLib obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    public TbVmsSymbLibDto mergeInfo(TbVmsSymbLibDto.TbVmsSymbLibUpdReq req) {
        req.setVmsTypeCd(this.VMP_TYPE_CD);
        req.setRgstDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
        TbVmsSymbLib obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    public TbVmsSymbLibDto deleteById(Integer id) {
        TbVmsSymbLib entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    public List<TbVmsSymbLibDto> deleteByIds(List<Integer> ids) {
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        for (Integer id : ids) {
            Optional<TbVmsSymbLib> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    public Integer findUsageCountBySymbolId(Integer id) {
        return this.formObjectRepository.findUsageCountBySymbolId(id);
    }

    public Integer getNewSymbolId(Integer min_val, Integer max_val) {
        return this.repo.getNewSymbolId(min_val, max_val);
    }
}
